package manage

import (
	"demo/configs"
	"demo/data/domain"
	"demo/data/domain/vo"
)

func GetByIdGoodsTag(id int) (domain.GoodsTag, error) {
	var goodsTag domain.GoodsTag
	_, err := configs.Engine.Where("id = ?", id).Get(&goodsTag)
	if err != nil {
		return goodsTag, err
	}
	return goodsTag, nil
}

func GetInIdListGoodsTag(ids []int) ([]domain.GoodsTag, error) {
	rows, err := configs.Engine.In("id", ids).Rows(&domain.GoodsTag{})
	if err != nil {
		return make([]domain.GoodsTag, 0), err
	}
	defer rows.Close()
	var list []domain.GoodsTag
	for rows.Next() {
		var u domain.GoodsTag
		list = append(list, u)
	}
	return list, nil
}

func GetListGoodsTag(goodsTag domain.GoodsTag, pageNum, pageSize int) (vo.BaseListVo, error) {
	rows, err := configs.Engine.Limit(pageSize, (pageNum-1)*pageSize).Desc("id").Rows(&goodsTag)
	var vo vo.BaseListVo
	if err != nil {
		return vo, err
	}
	vo.PageNum = pageNum
	vo.PageSize = pageSize
	vo.List = make([]any, 0)
	for rows.Next() {
		var u domain.GoodsTag
		rows.Scan(&u)
		vo.List = append(vo.List, u)
	}
	//查询数量
	count, err := configs.Engine.Count(&goodsTag)
	vo.Total = int(count)
	return vo, nil
}

func SaveGoodsTag(goodsTag *domain.GoodsTag) (domain.GoodsTag, error) {
	_, err := configs.Engine.Insert(&goodsTag)
	if err != nil {
		return *goodsTag, err
	}
	return *goodsTag, nil
}

func SetGoodsTag(goodsTagMap map[string]interface{}, id int) (domain.GoodsTag, bool, error) {
	var goodsTag domain.GoodsTag
	_, err := configs.Engine.Table("goods_tag").Where("id = ?", id).Update(goodsTagMap)
	if err != nil {
		return goodsTag, false, err
	}
	return goodsTag, true, nil
}

func DeleteGoodsTag(goodsTag domain.GoodsTag) bool {
	i, err := configs.Engine.Where("id = ?", goodsTag.Id).Delete(&goodsTag)
	if err != nil {
		return false
	}
	return i > 0
}
